#include "AI8051U.H"
#include "INTRINS.H"
#include "math.h"
#include "string.h"
#include "set_eeprom.h"
#include "set_io.h"
#include "set_pwm.h"
#include "set_spi.h"
#include "set_timer.h"
#include "set_uart.h"
#include "set_task.h"
#include "init.h"
#include "AI_USB.H"

volatile char* xdata mode_name[] = {"ģʽ","ģʽ","ģʽ","ٶģʽ"};
long moto_bps = 115200L;
int moto_pp = 7, moto_zero = 0, moto_dir = 0, moto_id = 0;//㣨1ͬ0෴ת,ͨѶid
unsigned char moto_mode = OpenLoop_Mode, moto_auto = 0;//ģʽУ׼־
volatile int xdata svpwm_dat[4096] = {0}; // Ԥ㻺
volatile char tle5012[10] = {0x80, 0x23, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
volatile char get_tle5012[8] = {0xd0, 0x82, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};//ȡòͷ
volatile char set_tle5012[8] = {0x50, 0x82, 0x08, 0x05, 0x00, 0x00, 0xff, 0xff};//ҪõĲ
unsigned int angle = 0, speed = 0, ppm = 0;

long moto_turns = 0;//ۼȦ
unsigned int last_postion = 0;//ϴλ

void DelayXms(unsigned int time)	//@40.000MHz
{
	unsigned long edata i;
	for(;time>0;time--)
	{
		_nop_();
		_nop_();
		_nop_();
		i = 9998UL;
		while (i) i--;
	}
}

void di_di_di(void)
{
	unsigned int t1 = 0,cnt = 0;
	for(t1 = 0; t1<3; t1++)
	{
		set_pwm_duty(Pwm1+t1, 52);
		for(cnt = 1; cnt<5; cnt++)
		{
			PWMA_PSCRL = cnt;		//
			DelayXms(70);
		}
		set_pwm_duty(Pwm1+t1, 50);
		DelayXms(100);
	}
	PWMA_PSCRL = 0;		//ֹͣ
}

// ûò
#define SVPWM_AMPLITUDE pwma_max/2 // ηֵֵӦpwmaֵ
#define SVPWM_POINTS_NUM 4096  // ݵ
#define M_PI 3.14159265358979323846f
#define _Conv 1.15470053838f
// κ
void GenerateSVPWMWave(void)
{
	float Max, Min, Adder, angle_el, Ua, Ub, Uc;
	int cnt;
	for (cnt = 0; cnt < SVPWM_POINTS_NUM; cnt++)
	{
		angle_el = cnt * 2 * M_PI / SVPWM_POINTS_NUM;
		// 任
		Ua = sin(angle_el);
		Ub = (sqrt(3) * cos(angle_el) - sin(angle_el)) / 2;
		Uc = (-sin(angle_el) - sqrt(3) * cos(angle_el)) / 2;
		// Fast_Svpwmʵ
		Max = Ua > Ub ? (Ua > Uc ? Ua : Uc) : (Ub > Uc ? Ub : Uc);
		Min = Ua < Ub ? (Ua < Uc ? Ua : Uc) : (Ub < Uc ? Ub : Uc);
		Adder = -(Max + Min) / 2;
		svpwm_dat[cnt] = (Ua + Adder) * _Conv * SVPWM_AMPLITUDE;
	}
}

void set_moto_duty(int ctrl_duty, unsigned int angle_el)//Χ4096~-4096
{
	if(pwma_dma_flag==0&&moto_auto==1&&moto_mode!=OpenLoop_Mode)//PWMDMAԶУ׼־Ϊ1(У׼)ִ
	{
		pwma_dma_dat[0] = ((svpwm_dat[((angle_el>>3)*moto_pp)%4096]*(long)ctrl_duty)>>12)+3000;
		pwma_dma_dat[1] = ((svpwm_dat[(((angle_el>>3)+1365)*moto_pp)%4096]*(long)ctrl_duty)>>12)+3000;
		pwma_dma_dat[2] = ((svpwm_dat[(((angle_el>>3)+2730)*moto_pp)%4096]*(long)ctrl_duty)>>12)+3000;
		DMA_PWMAT_CR = 0xc0;//PWMA_DMAķ
		pwma_dma_flag = 1;//趨æ־λ
	}
}

void set_moto_openloop(int ctrl_duty, unsigned int angle_el)//Χ4096~-4096
{
	if(pwma_dma_flag==0&&moto_mode == OpenLoop_Mode)//PWMDMA
	{
		pwma_dma_dat[0] = ((svpwm_dat[(angle_el)%4096]*(long)ctrl_duty)>>12)+3000;
		pwma_dma_dat[1] = ((svpwm_dat[((angle_el)+1365)%4096]*(long)ctrl_duty)>>12)+3000;
		pwma_dma_dat[2] = ((svpwm_dat[((angle_el)+2730)%4096]*(long)ctrl_duty)>>12)+3000;
		DMA_PWMAT_CR = 0xc0;//PWMA_DMAķ
		pwma_dma_flag = 1;//趨æ־λ
	}
}

void init(void)
{
	// ôűSPI
	set_io_mode(od_mode, Pin15, Pin_End);			   // MOSIΪ©㵥߶дд1ͷ
	set_io_mode(pp_mode, Pin14, Pin17, Pin_End);	   // SS,CLKΪ
	set_io_mode(high_speed, Pin14, Pin17, Pin_End);	   // SS,CLKΪ
	set_io_mode(big_current, Pin14, Pin17, Pin_End);   // SS,CLKΪ
	set_io_mode(en_pur, Pin14, Pin15, Pin16, Pin_End); // MISOMOSI
	// LEDָʾƲ
	set_io_mode(od_mode, Pin26, Pin_End); // Ϊ©ֻǿ0
	set_io_mode(en_pur, Pin26, Pin_End);  // 裬䵱LED
	// ź벿
	set_io_mode(en_pur, Pin25, Pin50, Pin_End); // 򿪴ߺPWMźߵ裬Ĭϸߵƽ
	set_spi_mode(SPI0, Low_Rising, Spi_ClkDiv_4, Spi_End);

	set_eeprom_mode(Hex_Mode, &moto_pp, sizeof(moto_pp));//󶨵
	set_eeprom_mode(Hex_Mode, &moto_zero, sizeof(moto_zero));//󶨵
	set_eeprom_mode(Hex_Mode, &moto_dir, sizeof(moto_dir));//󶨵
	set_eeprom_mode(Hex_Mode, &moto_auto, sizeof(moto_auto));//󶨵У׼־
	set_eeprom_mode(Hex_Mode, &moto_mode, sizeof(moto_mode));//󶨵ģʽ
	set_eeprom_mode(Hex_Mode, &moto_id, sizeof(moto_id));//ͨѶid
	set_eeprom_mode(Hex_Mode, &moto_bps, sizeof(moto_bps));//󶨲
	set_eeprom_sync(Pull);//ȡֵ

	set_pwm_fosc(40e6);//PLLPWMBʱΪ40MhzҪһ
	set_pwm_mode(Pwm7, Pwm7_P25, Pwm_In_Mode, Self_Capture, Cap_In_Rising_Edge, Pwm_End);
	set_pwm_mode(Pwm8, Pwm_In_Mode, Cross_Capture, Cap_In_Falling_Edge, Pwm_End);

	set_timer_fosc(40e6);
	set_timer_mode(Timer0, "1ms", Timer_End);
	set_timer_isr(Timer0, set_task_mode);

	set_pwm_fosc(120e6);//PLLPWMʱΪ120MhzҪһ
	set_pwm_mode(Pwm1, Pwm1_P20_21, "20khz", "50%", Dis_Out, Pwm_End);
	set_pwm_mode(Pwm2, Pwm2_P22_23, "50%", Dis_Out, Pwm_End);
	set_pwm_mode(Pwm3, Pwm3_P24_25, "50%", Dis_Out, Pwm_End);
	//set_pwm_mode(Pwm4, Pwm4_P26_27, "80%", Pwm_End);
	set_pwma_dma(4);//дĸ
	// PWM
	P20 = P22 = P24 = 0;									// õ͵ƽ
	set_io_mode(pp_mode, Pin20, Pin22, Pin24, Pin_End);		// PWMΪ
	set_io_mode(high_speed, Pin20, Pin22, Pin24, Pin_End);	// PWMΪ
	set_io_mode(big_current, Pin20, Pin22, Pin24, Pin_End); // PWMΪ
	PWMA_ENO = 0x15;//PWMAʹ
	di_di_di();//Լ
	GenerateSVPWMWave();//SVPWM
	DelayXms(100);
	HSPWMA_CFG |= 0x02;//ʹPWMAΪ첽ģʽ
	CLKSEL |= 0x40;//PLLΪIOʱ
	DelayXms(100);
	//set_uart_mode(Uart3, Uart3_P50_1, Use_Timerx, Uart_End);
	P14 = 0;// CS
	spi_printf(SPI0, Buff_Mode, get_tle5012, 8);
	
	*((unsigned int *)&set_tle5012[4]) &= ~(0xfff0);//ջ׼׼ǶϢ
	// *((unsigned int *)&set_tle5012[4]) = ((3942)<<4);//ö׼Ƕ(0~4096)
	if(moto_auto == 0)*((unsigned int *)&set_tle5012[4]) |= ((0)<<4);//ö׼Ƕ(0~4096)
	else *((unsigned int *)&set_tle5012[4]) |= ((moto_zero)<<4);//ö׼Ƕ(0~4096)
	set_tle5012[3] &= ~(1<<3);//־λ
	if(moto_auto == 0)set_tle5012[3] |= ((0)<<3);//÷(01),δУ׼ʱ̶Ϊ0
	else set_tle5012[3] |= ((moto_dir&1)<<3);
	while(!get_spi_state(SPI0));
	P14 = 1;// CS
	while (strncmp(&_spi0_rx_buff[2], &set_tle5012[2], 4))//ͬд룬ͬ
	{
		P14 = 0;// CS
		spi_printf(SPI0, Buff_Mode, set_tle5012, 8);
		while(!get_spi_state(SPI0));//ȴд
		P14 = 1;// CS
	}
	P14 = 0;			// CS
	spi_printf(SPI0, Buff_Mode, tle5012, 10); // ̶ȡ
	last_postion = 0;
	moto_turns = 0;
}

void sync_postion_dat(void)//λû
{
	int tmp_postion = 0;
	tmp_postion += (int)ppm-(int)last_postion;
	if(tmp_postion > 200)tmp_postion-=512;
	if(tmp_postion < -200)tmp_postion+=512;
	moto_turns += tmp_postion;//Ȧ
	last_postion = ppm;
}

long get_postion(void)//ȡλû
{
	sync_postion_dat();
	return (moto_turns*32768L)+angle;
}

